/*
 * kbdMapMach.h --
 *
 *	Hardware-dependent declarations of data structures to 
 *	map raw keyboard input to ASCII characters.
 *
 * Copyright 1986,1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: kbdMapMach.h,v 1.1 88/07/20 22:01:20 douglis Exp $ SPRITE (Berkeley)
 */

#ifndef _KBDMAPMACH
#define _KBDMAPMACH

/* constants */

/*
 * Ascii values of command keys.
 */

#define KBD_ESC		27
#define KBD_TAB		'\t'
#define KBD_DEL		127
#define KBD_BACKSP	'\b'
#define KBD_RET		'\r'
#define KBD_LF		'\n'

/*
 *  Define "hardware-independent" codes for the control, shift, meta and 
 *  function keys.  Codes start after the last 7-bit ASCII code (0x7F) 
 *  and are assigned in an arbitrary order.
 */

#define KBD_NOKEY	128
#define KBD_UNKNOWN	129


#define KBD_LEFT_F1	201
#define KBD_LEFT_F2	202
#define KBD_LEFT_F3	203
#define KBD_LEFT_F4	204
#define KBD_LEFT_F5	205
#define KBD_LEFT_F6	206
#define KBD_LEFT_F7	207
#define KBD_LEFT_F8	208
#define KBD_LEFT_F9	209
#define KBD_LEFT_F10	210

#define KBD_LEFT_START	KBD_LEFT_F1
#define KBD_LEFT_END	KBD_LEFT_F10

#define KBD_TOP_F1	211
#define KBD_TOP_F2	212
#define KBD_TOP_F3	213
#define KBD_TOP_F4	214
#define KBD_TOP_F5	215
#define KBD_TOP_F6	216
#define KBD_TOP_F7	217
#define KBD_TOP_F8	218
#define KBD_TOP_F9	219
#define KBD_TOP_F10	220

#define KBD_TOP_START	KBD_TOP_F1
#define KBD_TOP_END	KBD_TOP_F10

#define KBD_RIGHT_F1	221
#define KBD_RIGHT_F2	222
#define KBD_RIGHT_F3	223
#define KBD_RIGHT_F4	224
#define KBD_RIGHT_F5	225
#define KBD_RIGHT_F6	226
#define KBD_RIGHT_F7	227
#define KBD_RIGHT_F8	228
#define KBD_RIGHT_F9	229
#define KBD_RIGHT_F10	230
#define KBD_RIGHT_F11	231
#define KBD_RIGHT_F12	232
#define KBD_RIGHT_F13	233
#define KBD_RIGHT_F14	234
#define KBD_RIGHT_F15	235

#define KBD_RIGHT_START	KBD_RIGHT_F1
#define KBD_RIGHT_END	KBD_RIGHT_F15

#define KBD_LEFT	240
#define KBD_RIGHT	241
#define KBD_CONTROL	242
#define KBD_SHIFT	243
#define KBD_CAPSLOCK	244
#define KBD_ALTERNATE	245

#define KBD_MAX_VALUE	KBD_ALTERNATE

#define KBD_SPECIAL	KBD_LEFT_F1


extern unsigned short	devKbdSunToShiftedAscii[];
extern unsigned short	devKbdSunToUnshiftedAscii[];

#endif _KBDMAPMACH
